Unit DE58R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTDE14_p;

procedure DE58R(FK :Func_F_DE; FG :Func_F_DE; FR :Func_F_DE; NX :Integer;
                var X :Array of Real; GN1 :Boolean;
                var GN :Array of Real; GK1 :Boolean;
                var GK :Array of Real; var Y :Array of Real;
                var ALP :Array of Extended; var BET :Array of Extended;
                var IERR :Integer);

implementation

procedure DE58R(FK :Func_F_DE; FG :Func_F_DE; FR :Func_F_DE; NX :Integer;
                var X :Array of Real; GN1 :Boolean;
                var GN :Array of Real; GK1 :Boolean;
                var GK :Array of Real; var Y :Array of Real;
                var ALP :Array of Extended; var BET :Array of Extended;
                var IERR :Integer);
var
I,J,NXM1 :Integer;
XP :Real;
H1,R,RA1,RA,RA2,H,R1,Z :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
IERR := 0;
if ( GN1 ) 
 then goto _1;
if ( GN[0] >= 0.0 ) 
 then goto _1;
IERR := 65;
goto _15;
_1:
if ( GK1 ) 
 then goto _2;
if ( GK[0] >= 0.0 ) 
 then goto _2;
IERR := 66;
goto _15;
_2:
if ( NX > 1 ) 
 then goto _3;
IERR := 69;
goto _15;
_3:
NXM1 := NX-1;
H1 := X[1]-X[0];
if ( H1 <= 0.e0 ) 
 then goto _14;
R := 0.5e0*H1;
XP := X[0]+R;
RA1 := FK(XP);
if ( RA1 <= 0.e0 ) 
 then goto _12;
if ( GN1 ) 
 then goto _4;
RA := RA1/H1;
RA2 := FG(X[0]);
if ( RA2 < 0.e0 ) 
 then goto _13;
RA2 := RA+GN[0]+R*RA2;
ALP[0] := RA/RA2;
BET[0] := (R*FR(X[0])+GN[1])/RA2;
goto _5;
_4:
ALP[0] := 0.e0;
BET[0] := GN[0];
_5:
if ( NX = 2 ) 
 then goto _7;
for I:=2 to NXM1 do
 begin
  H := H1;
  RA := RA1;
  H1 := X[I+0]-X[I-1];
  if ( H1 <= 0.e0 ) 
   then goto _14;
  R := H/H1;
  RA1 := (H+H1)*0.5e0;
  R1 := H*RA1;
  XP := XP+RA1;
  RA1 := FK(XP);
  if ( RA1 <= 0.e0 ) 
   then goto _12;
  RA2 := FG(X[I-1]);
  if ( RA2 < 0.e0 ) 
   then goto _13;
  R := RA1*R;
  RA2 := RA+R+R1*RA2-ALP[I-2]*RA;
  RA2 := 1.e0/RA2;
  ALP[I-1] := R*RA2;
  BET[I-1] := RA*BET[I-2]*RA2+R1*FR(X[I-1])*RA2;
_6:
 end;
_7:
if ( GK1 ) 
 then goto _8;
RA := RA1/H1;
R := 0.5e0*H1;
RA2 := FG(X[NX-1]);
if ( RA2 < 0.e0 ) 
 then goto _13;
RA2 := RA+GK[0]+R*RA2;
RA := RA/RA2;
RA1 := (R*FR(X[NX-1])+GK[1])/RA2;
goto _9;
_8:
Y[NX-1] := GK[0];
Z := Y[NX-1];
goto _10;
_9:
Z := (RA1+RA*BET[NXM1-1])/(1.e0-ALP[NXM1-1]*RA);
Y[NX-1] := Z;
_10:
for I:=1 to NXM1 do
 begin
  J := NX-I;
  Z := ALP[J-1]*Z+BET[J-1];
  Y[J-1] := Z;
_11:
 end;
goto _15;
_12:
IERR := 67;
goto _15;
_13:
IERR := 68;
goto _15;
_14:
IERR := 70;
_15:
if ( IERR <> 0 ) 
 then UTDE14(IERR,58);
end;

end.
